'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _isTag = require('../utils/isTag');

var _isTag2 = _interopRequireDefault(_isTag);

var _ThemeProvider = require('./ThemeProvider');

var _InlineStyle = require('./InlineStyle');

var _InlineStyle2 = _interopRequireDefault(_InlineStyle);

var _AbstractStyledComponent = require('./AbstractStyledComponent');

var _AbstractStyledComponent2 = _interopRequireDefault(_AbstractStyledComponent);

var _constructWithOptions = require('../constructors/constructWithOptions');

var _constructWithOptions2 = _interopRequireDefault(_constructWithOptions);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

function _toConsumableArray(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = Array(arr.length); i < arr.length; i++) { arr2[i] = arr[i]; } return arr2; } else { return Array.from(arr); } }

var babelPluginFlowReactPropTypes_proptype_Theme = require('./ThemeProvider').babelPluginFlowReactPropTypes_proptype_Theme || require('react').PropTypes.any;

var babelPluginFlowReactPropTypes_proptype_Target = require('../types').babelPluginFlowReactPropTypes_proptype_Target || require('react').PropTypes.any;

var babelPluginFlowReactPropTypes_proptype_RuleSet = require('../types').babelPluginFlowReactPropTypes_proptype_RuleSet || require('react').PropTypes.any;

var createStyledNativeComponent = function createStyledNativeComponent(target, options, rules) {
  var _options$displayName = options.displayName,
      displayName = _options$displayName === undefined ? (0, _isTag2.default)(target) ? 'styled.' + target : 'Styled(' + target.displayName + ')' : _options$displayName,
      _options$rules = options.rules,
      extendingRules = _options$rules === undefined ? [] : _options$rules,
      _options$ParentCompon = options.ParentComponent,
      ParentComponent = _options$ParentCompon === undefined ? _AbstractStyledComponent2.default : _options$ParentCompon;

  var inlineStyle = new _InlineStyle2.default([].concat(_toConsumableArray(extendingRules), _toConsumableArray(rules)));

  var StyledNativeComponent = function (_ParentComponent) {
    _inherits(StyledNativeComponent, _ParentComponent);

    function StyledNativeComponent() {
      var _ref;

      var _temp, _this, _ret;

      _classCallCheck(this, StyledNativeComponent);

      for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
        args[_key] = arguments[_key];
      }

      return _ret = (_temp = (_this = _possibleConstructorReturn(this, (_ref = StyledNativeComponent.__proto__ || Object.getPrototypeOf(StyledNativeComponent)).call.apply(_ref, [this].concat(args))), _this), _this.state = {
        theme: {},
        generatedStyles: undefined
      }, _temp), _possibleConstructorReturn(_this, _ret);
    }

    _createClass(StyledNativeComponent, [{
      key: 'componentWillMount',
      value: function componentWillMount() {
        var _this2 = this;

        // If there is a theme in the context, subscribe to the event emitter. This
        // is necessary due to pure components blocking context updates, this circumvents
        // that by updating when an event is emitted
        if (this.context[_ThemeProvider.CHANNEL]) {
          var subscribe = this.context[_ThemeProvider.CHANNEL];
          this.unsubscribe = subscribe(function (nextTheme) {
            // This will be called once immediately
            var defaultProps = _this2.constructor.defaultProps;
            // Props should take precedence over ThemeProvider, which should take precedence over
            // defaultProps, but React automatically puts defaultProps on props.

            var isDefaultTheme = defaultProps && _this2.props.theme === defaultProps.theme;
            var theme = _this2.props.theme && !isDefaultTheme ? _this2.props.theme : nextTheme;
            var generatedStyles = _this2.generateAndInjectStyles(theme, _this2.props);
            _this2.setState({ generatedStyles: generatedStyles, theme: theme });
          });
        } else {
          var _theme = this.props.theme || {};
          var generatedStyles = this.generateAndInjectStyles(_theme, this.props);
          this.setState({ generatedStyles: generatedStyles, theme: _theme });
        }
      }
    }, {
      key: 'componentWillReceiveProps',
      value: function componentWillReceiveProps(nextProps) {
        var _this3 = this;

        this.setState(function (oldState) {
          var theme = nextProps.theme || oldState.theme;
          var generatedStyles = _this3.generateAndInjectStyles(theme, nextProps);

          return { theme: theme, generatedStyles: generatedStyles };
        });
      }
    }, {
      key: 'componentWillUnmount',
      value: function componentWillUnmount() {
        if (this.unsubscribe) {
          this.unsubscribe();
        }
      }
    }, {
      key: 'generateAndInjectStyles',
      value: function generateAndInjectStyles(theme, props) {
        var executionContext = _extends({}, props, { theme: theme });
        return inlineStyle.generateStyleObject(executionContext);
      }
      /* eslint-disable react/prop-types */

    }, {
      key: 'render',
      value: function render() {
        var _props = this.props,
            style = _props.style,
            children = _props.children,
            innerRef = _props.innerRef;
        var generatedStyles = this.state.generatedStyles;


        var propsForElement = _extends({}, this.props);
        propsForElement.style = [generatedStyles, style];
        if (innerRef) {
          propsForElement.ref = innerRef;
          delete propsForElement.innerRef;
        }

        return (0, _react.createElement)(target, propsForElement, children);
      }
    }], [{
      key: 'extend',
      get: function get() {
        return StyledNativeComponent.extendWith(target);
      }
    }]);

    return StyledNativeComponent;
  }(ParentComponent);

  StyledNativeComponent.displayName = displayName;
  StyledNativeComponent.extendWith = function (tag) {
    var _ = options.displayName,
        optionsToCopy = _objectWithoutProperties(options, ['displayName']);

    return (0, _constructWithOptions2.default)(createStyledNativeComponent, tag, _extends({}, optionsToCopy, { rules: rules, ParentComponent: StyledNativeComponent }));
  };

  return StyledNativeComponent;
};

exports.default = createStyledNativeComponent;
module.exports = exports['default'];